commit 276648888d26a931606108981b46ac7bfedf7122
Author: Harald Anlauf <anlauf@gmx.de>
Date:   Tue Jan 25 21:56:39 2022

    Fortran: MOLD argument to TRANSFER intrinsic having storage size zero
    
    gcc/fortran/ChangeLog:
    
            PR fortran/104227
            * check.c (gfc_calculate_transfer_sizes): Fix checking of arrays
            passed as MOLD argument to the TRANSFER intrinsic for having
            storage size zero.
    
    gcc/testsuite/ChangeLog:
    
            PR fortran/104227
            * gfortran.dg/transfer_check_6.f90: New test.
    
    (cherry picked from commit ec543c9833c2d9283c035cd8430849eb4ec04406)

diff --git a/gcc/fortran/check.c b/gcc/fortran/check.c
index e110ca01f2f..294e0b3ec5b 100644
--- a/gcc/fortran/check.c
+++ b/gcc/fortran/check.c
@@ -6134,7 +6134,7 @@ gfc_calculate_transfer_sizes (gfc_expr *source, gfc_expr *mold, gfc_expr *size,
    * If SIZE is present, the result is an array of rank one and size SIZE.
    */
   if (result_elt_size == 0 && *source_size > 0 && !size
-      && mold->expr_type == EXPR_ARRAY)
+      && (mold->expr_type == EXPR_ARRAY || mold->rank))
     {
       gfc_error ("%<MOLD%> argument of %<TRANSFER%> intrinsic at %L is an "
 		 "array and shall not have storage size 0 when %<SOURCE%> "
diff --git a/gcc/testsuite/gfortran.dg/transfer_check_6.f90 b/gcc/testsuite/gfortran.dg/transfer_check_6.f90
new file mode 100644
index 00000000000..dffd0913f0d
--- /dev/null
+++ b/gcc/testsuite/gfortran.dg/transfer_check_6.f90
@@ -0,0 +1,11 @@
+! { dg-do compile }
+! PR fortran/104227 - ICE virtual memory exhausted
+! Contributed by G.Steinmetz
+
+program p
+  type t
+  end type
+  type(t) :: x(2)
+  print *, transfer(1, x) ! { dg-error "shall not have storage size 0" }
+  x = transfer(1, x)      ! { dg-error "shall not have storage size 0" }
+end

